// Copyright (C) 2003  Daniel De Graaf
// Functions 10-19 (not 14)
#include "defines.h"

Func info(FuncArgs) {
	HANDLE h=GetValue(args,1,2000);
	BYTE* f = HeapDeref(h);
	ERR(!f);
	WORD size = *((WORD*)(f));
	short type = f[size+1];
	DefData(18); //(list=2) + 3*(integer=4) + (endData=4)
	data[0] = END_TAG;
	IntData(size,1);
	IntData(HeapSize(h),5);
	IntData(type,9);
	data[13] = LIST_TAG;
	EndData(14);
	return d_h;
}

Func read(FuncArgs) {
	HANDLE h=GetInt(1,2000);
	BYTE* f=HeapDeref(h);
	ERR(!f);
	return OneInt(f[1 + GetValue(args,-1,HeapSize(h))]);
}

Func write(FuncArgs) {
	HANDLE h=GetInt(1,2000);
	BYTE* f=HeapDeref(h) + 1 + GetInt(-1,HeapSize(h)-1);
	*f = GetValue(args,0,255);
	return 0;
}

Func create(FuncArgs) {
	ERR (*args != STR_TAG);
	string name = GetSymstrArg(args);
	long size = GetValue(args,0,65518);
	HANDLE h = HeapAlloc(size+2);
	ERR(!h);
	HSym t = SymAdd(name);
	if (!t.folder) {
		HeapFree(h);
		return 0;
	}
	DerefSym(t)->handle = h;
	*((WORD*)HeapDeref(h)) = size; //set size
	return OneInt(h);
}

//batt in asm

Func getKey(FuncArgs) {
	short val=ngetchx(); //ngetchx CAN cause heap movement (silent link)
	OSClearBreak();
	return OneInt(val);
}

Func ErrTxt(FuncArgs) {
	string e = find_error_message(GetValue(args,0,0x7FFF)); //points to ROM
	ERR (!e);
	short len = strlen(e) + 3;
	DefData(len);
	data[0] = 0;
	strcpy(data+1,e);
	data[len-1] = STR_TAG;
	return d_h;
}

Func dir(FuncArgs) {
	SYM_ENTRY* q;
	char buffer[5500]; //very big buffer
	short bp=0;
	if (*args == STR_TAG)
		q = SymFindFirst(GetSymstrArg(args),FO_SINGLE_FOLDER);
	else
		q = SymFindFirst(0,0);
	while (q) {
		buffer[bp++]=0;
		memcpy(buffer + bp,q->name,8);
		short l=strlen(q->name);
		bp += l;
		buffer[bp++]=0;
		buffer[bp++]=STR_TAG;
		q = SymFindNext();
	}
	DefData(bp + 2);
	data[0] = END_TAG;
	memcpy(data+1,buffer,bp);
	data[bp+1] = LIST_TAG;
	return d_h;
}

Func HomeScr(FuncArgs) {
	ERR (*args != STR_TAG);
	push_parse_text(GetStrnArg(args));
	HomePushEStack();
	return 0;
}

Func linkRW(FuncArgs) {
	BYTE d[0x880];
	if (*args == LIST_TAG) {
		args--;
		OSLinkOpen();
		short n;
		for(n=0; (*args != END_TAG) && (n < 0x800); n++)
			d[n] = GetInt(0,255);
		BYTE* e=d; //must be movable
		while (n > 128) {
			OSWriteLinkBlock(e,n);
			e += 128; n -= 128;
		}
		OSWriteLinkBlock(e,n);
		OSLinkClose();
		return 0;
	}	if (*args == TRUE_TAG) {
		short NumBytes = 0,x;
		args--;
		DWORD timer = FiftyMsecTick + OptInt(1,3000,50);
		while ((FiftyMsecTick < timer) && (NumBytes < 0x800))
			NumBytes += OSReadLinkBlock(d + NumBytes, 128);
		OSLinkClose();
		ERR(!NumBytes);
		DefData(NumBytes*4+6);//Int, list, (-1)
		*data = END_TAG;
		for(x=0;x < NumBytes;x++)
			IntData(d[NumBytes - x - 1],4*x+1); //2 because we want 0x00 to 0xFF to pass
		data[NumBytes*4+1] = LIST_TAG;
		EndData(NumBytes*4+2);
		return d_h;
	}	if (IsInt) {
		OSLinkOpen();
		*d=GetLastInt(0,255);
		OSWriteLinkBlock(d,1);
		OSLinkClose();
		return 0;
	} else {
		short x=0;
		DWORD timer = FiftyMsecTick + 50;
		while (!(x=OSReadLinkBlock(d,1)) && (FiftyMsecTick < timer));
			//timer so we don't wait forever
		OSLinkClose();
		if (x) return OneInt(*d);
		DefData(1);
		*data = FALSE_TAG;
		return d_h;
}	}
