// Copyright (C) 2003  Daniel De Graaf
// Functions 20-29
#include "defines.h"

Func SysSet(FuncArgs) {
	short contrast = GetInt(0,3);
	if (contrast == 1) OSContrastUp();
	if (contrast == 2) OSContrastDn();
	short apd = GetValue(args,10,20*60*10);//10 minute max
	OSFreeTimer(APD_TIMER);
	OSRegisterTimer(APD_TIMER,apd);
	return 0;
}

Func pushKey(FuncArgs) {
	pushkey(GetValue(args,1,0x7FFF));
	return 0;
}

Func clipB(FuncArgs) {
	HANDLE h;
	DWORD len;
	WORD r=CB_fetchTEXT(&h, &len);
	if (*args == STR_TAG) {
		string toput = GetStrnArg(args);
		CB_replaceTEXT((char*)(toput), strlen(toput), 0);
	}
	ERR (!r);
	DefData(len+3);
	*data=0;
	memcpy(data+1,HeapDeref(h), len);
	data[len+1]=0;
	data[len+2]=STR_TAG;
	return d_h;
}

Func menu(FuncArgs) {
	short r; (*args == TRUE_TAG) ? (args--,r=1) : (r=0);
	string t = (*args == STR_TAG) ? GetStrnArg(args) : NULL;
//new popup
	HANDLE m = PopupNew(t,0);
	short x = OptInt(0,240,-1);
	short y = OptInt(0,128,-1);
	short c=1;
//settings - done
	ERR (*(args--) != LIST_TAG);
	while (*(args--) == LIST_TAG) { //matrix <-> list of lists
		string i= GetStrnArg(args);
		short n = GetInt(0,4095);
		PopupAddText(m,n,i,c++);
		args--;
	}
//setup - done

	if (!r) { //simple menu
		HANDLE d_h = OneInt(PopupDo(m,x,y,0));
		HeapFree(m);
		return d_h;
	}
//begin popup
	HANDLE exec=PopupBegin(m,0);
//let user think
	while (r) {
		r = PopupBeginDo(exec,x,y,0);
		MenuCheck(exec,r,MC_FLIP);
	}
//recurse through all
	short tmp[c+1];
	for(r=0, x=0; r<c; r++) if (MenuCheck(exec,r,MC_STATUS)) tmp[x++] = r;
//allocate
	DefData(x*4+6);
	data[0] = END_TAG;
//insert (backwards so the data in order in the list)
	for(r=x-1, c=1; r>=0; r--, c += 4) 
		IntData(tmp[r],c);
//finish
	data[c++] = LIST_TAG; //c is ready for the next expression
	EndData(c);
//free temp data
	MenuEnd(exec);
	return d_h;
}

Func VarMenu(FuncArgs) {
/*
.even
EventGet:
	move.l 4(%sp),%a0 |EVENT*
	cmp.w #0x724,(%a0)
	jbne PassOn
	lea _nostub, %a1
	move.w 8(%a0),(%a1) |HANDLE
	move.w #0x700,(%a0)
PassOn:
	rts
	if (IsInt) {
		HANDLE h=GetInt(1,2000);
		asm("
	lea _nostub(%%pc), %%a2 | Global variable
	clr.w (%%a2)
	move.l 0xC8,%%a0
	move.l 2700(%%a0),%%a3  | a3 = EV_hook; d3 = *a3;
	move.l (%%a3),%%d3
	move.l EventGet(%%pc),(%%a3) | *EV_hook = EventGet; 
	move.w %1,-(%%sp)
	.word _F_LINE+0x129 | HandleVarLinkKey(h);
	move.l %%d3,(%%a3)  | restore EV_hook
	move.w (%%a2),%0" :
	"=d" (h) : "d" (h): "a0","a1","a2","a3","d0","d1","d2","d3");
		ERR (!h);
		char* s = HeapDeref(h);
		short k = strlen(s)+3;
		DefData(k);
		*data=0;
		strcpy(data+1,s);
		data[k-1] = STR_TAG;
		HeapFree(h);
		return d_h;
	}//*/
//	short r; if (*args == TRUE_TAG) args--,r=1; else r=0;
	string t = (*args == STR_TAG) ? GetStrnArg(args) : NULL;
//new popup
	HANDLE p=PopupNew(t,0);
	short xpos = OptInt(0,240,-1);
	short ypos = OptInt(0,128,-1);

	char tmp[19]; //8 letters folder+8 letters var + '\' + 2 '0'
	short x,y,z;
	SYM_ENTRY* vartable; tmp[0] = 0;
//Lock the folder tables so that heap compression doesn't move them
	FolderOp(0, FOP_ALL_FOLDERS | FOP_LOCK);
	SYM_ENTRY* foldtable = SymFindFirst(0,4); //skip temp folders
//count folders
	for (z=1; SymFindNext(); z++);
	short numfold=z, start[z];

//create menu
	for(x=0; x < numfold; x++) {
		short infold=FolderCount(&foldtable[x]);
		PopupAddText(p, 0, foldtable[x].name, x+1);
		start[x]=++z;
		PopupAddText(p, x+1, "<Folder>", z++);
		vartable = (SYM_ENTRY*)((char*)HeapDeref(foldtable[x].handle) + 4);
		for(y=0; y < infold; y++)
			PopupAddText(p, x+1, vartable[y].name, z++);
	}
	

	short result = PopupDo(p, xpos, ypos, 0);

	HeapFree(p);
	if (result <= numfold) {//picked nothing
	 FolderOp(0, FOP_ALL_FOLDERS | FOP_UNLOCK);
	 return 0;	
	}
///search for the result///
	x=0;
	while (x < numfold) {
		if (start[x] > result) break;
		x++;
	}
	y = result - start[--x] - 1;
	vartable = (SYM_ENTRY*)((char*)HeapDeref(foldtable[x].handle) + 4);
//x     = folder number
//y     = variable number (-1 if "<folder>")
	strcpy(tmp,foldtable[x].name);
	strcat(tmp,"\\");
	if (y >= 0)	strcat(tmp,vartable[y].name);
	FolderOp(0, FOP_ALL_FOLDERS | FOP_UNLOCK);
	//string is in tmp
	x=strlen(tmp)+3;
	DefData(x);
	data[0]=0;
	strcpy(data+1,tmp);
	data[x-1]=STR_TAG;
	return d_h;
}

Func detokenize(FuncArgs) {
	short len; char* data;
	short tmp = GetValue(args,1,2000);
	HeapLock(tmp);
	HANDLE d_h=0;
//d_h = NG_RPNToText(tmp,0,1) does not work for programs

	BYTE* x=HToESI(tmp);
	if (*x == FUNC_TAG) {
		if (*(x-1) & 8) { //edit flag
			//this is a program that has just been edited
			BYTE* q=HeapDeref(tmp);
			len=strlen(q+2);
			d_h=HeapAlloc(len+5);
			data=HeapDeref(d_h);
			memmove(data+3,q+2,len);
			goto TxtPrgm; 
				// goto is the fastest & shortest method here
		}
		x = GetFuncPrgmBodyPtr(x);
	}
	d_h = display_statements(x,0,1);
	HeapUnlock(tmp);
	ERR(!d_h);
	len = strlen(HeapDeref(d_h));
	if (!HeapRealloc(d_h,len+5)) {HeapFree(d_h); return 0;}
	data=HeapDeref(d_h);
	memmove(data+3,data,len);
TxtPrgm:
	*((WORD*)data) = (len+3);
	data[2] = 0;
	data[len+3]=0;
	data[len+4]=STR_TAG;
	return d_h;
}

Func GetHSHandle(FuncArgs) {
	short n = GetValue(args,0,99);
	WORD f = HS_getFIFONode(n);
	ERR(!f); //does not exist
	DefData(18);
	FIFO_NODE* x = HeapDeref(f);
	data[0] = END_TAG;
	IntData(f,1);
	IntData(x->Ans.Expr,5);
	IntData(x->Entry.Expr,9);
	data[13] = LIST_TAG;
	EndData(14);
	return d_h;
}

Func ReadMem(FuncArgs) {
	BYTE* n = (void*)GetInt(0,0x7FFFFF); //cast argument to pointer
	if (IsInt) {
		short nb=GetLastInt(0,255);
		if (!nb) {
			nb = strlen(n);
			DefData(3+nb);
			*data = 0;
			memcpy(data+1,n,nb+1);
			data[nb+2] = STR_TAG;
			return d_h;
		}
		DefData(2+nb);
		data[nb] = nb;
		data[nb+1] = POSINT_TAG;
		while(nb > 0) data[--nb] = *(n++);
		return d_h;
	}
	return OneInt(*n);
}

Func WriteMem(FuncArgs) {
	BYTE* n = (BYTE*)GetInt(0,0x7FFFFF); //cast argument to pointer
	if (*args == STR_TAG) {
		string z = GetStrnArg(args);
		strcpy(n,z);
		return 0;
	}
	ERR (*args != POSINT_TAG); //Cannot be float
	//else *(BYTE*)(n) = GetValue(args,0,255);

	short len = *(--args);
	if (len == 0)
		*n = 0; //0 has no length, would not be written
	else
		for(;len;len--) *(n++) = *(--args);
	return 0;
}

Func GetAddrHand(FuncArgs) {
	HANDLE h=GetInt(1,2000);
	HeapCompress();
	//so that there are few errors in BASIC programs that don't lock handles
	if (*args == TRUE_TAG) HeapLock(h);
	if (*args == FALSE_TAG) HeapUnlock(h);
	DefData(9);
	DWORD x=(DWORD)(HeapDeref(h)+1);
	data[0] = x;         //too big for IntData (16-bit max)
	data[1] = x/0x100;
	data[2] = x/0x10000; //addresses are 24-bit (actually 23)
	data[3] = 3;
	data[4] = POSINT_TAG;
	EndData(5);
	return d_h;
}
